/* Name.h presents accessor methods for class Name.
 * ...
 */

#include <iostream>    // ostream
#include <string>      // the string class
#include <cassert>     // assert()
using namespace std;

class Name
{
 public:
   Name();
   Name(string first, string middle, string last);
   
   string getFirstName() const;
   string getMiddleName() const;
   string getLastName() const;
   string getSignature() const;
   char   getMiddleInitial() const;
   
   void print(ostream& out) const;
   void read(istream& in);
   
   // ... other Name-operation declarations go here
 private:
   string myFirstName, 
          myMiddleName, 
          myLastName;
};

inline Name::Name()
{
   myFirstName = myMiddleName = myLastName = "";
}

inline Name::Name(string first, string middle, string last)
{
   myFirstName = first;
   myMiddleName = middle;
   myLastName = last;
}

inline string Name::getFirstName() const
{
   return myFirstName;
}

inline string Name::getMiddleName() const
{
   return myMiddleName;
}

inline string Name::getLastName() const
{
   return myLastName;
}
   
inline char Name::getMiddleInitial() const
{
   assert(myMiddleName.size() > 0);
   return myMiddleName[0];
}

inline string Name::getSignature() const
{
  return getFirstName() + ' ' 
         + getMiddleInitial() + ". "
         + getLastName();
}

inline void Name::print(ostream& out) const
{
   out << getFirstName() + ' '
          + getMiddleName() + ' '
          + getLastName();
}

inline void Name::read(istream& in)
{
   in >> myFirstName >> myMiddleName >> myLastName;
}

